// Display.cpp : implementation file
//

#include "stdafx.h"
#include "PXAEmu.h"
#include "Display.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define DISPLAY_BGCOLOR RGB(0x83, 0x9C, 0x6A)

/////////////////////////////////////////////////////////////////////////////
// CDisplay

CDisplay::CDisplay()
{
	m_nPixelSize = 5;
	m_nGapSize = 0;

	memset(m_display, 0xFF, DISPLAY_WIDTH*DISPLAY_HEIGHT/8);
}

CDisplay::~CDisplay()
{
}


BEGIN_MESSAGE_MAP(CDisplay, CStatic)
	//{{AFX_MSG_MAP(CDisplay)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDisplay message handlers

void CDisplay::OnPaint() 
{
	CRect rectUpdate;
	GetUpdateRect(rectUpdate);
	CPaintDC dc(this); // device context for painting

	CRect rect;
	GetClientRect(rect);

	dc.FillSolidRect(CRect(rect.left,rectUpdate.top, rect.left+m_nBorder, rectUpdate.bottom), DISPLAY_BGCOLOR);
	dc.FillSolidRect(CRect(rect.right - m_nBorder,rectUpdate.top,rect.right, rectUpdate.bottom), DISPLAY_BGCOLOR);
	dc.FillSolidRect(CRect(rectUpdate.left,rect.top,rectUpdate.right, rect.top+m_nBorder), DISPLAY_BGCOLOR);
	dc.FillSolidRect(CRect(rectUpdate.left,rect.bottom-m_nBorder,rectUpdate.right, rect.bottom), DISPLAY_BGCOLOR);
	
	rectUpdate.left = max(0, (rectUpdate.left - m_nBorder) / (m_nPixelSize + m_nGapSize));
	rectUpdate.right = min(DISPLAY_WIDTH, (rectUpdate.right - m_nBorder) / (m_nPixelSize + m_nGapSize));
	rectUpdate.top = max(0,(rectUpdate.top - m_nBorder) / (m_nPixelSize + m_nGapSize) * 8);
	rectUpdate.bottom = (min(DISPLAY_HEIGHT, (rectUpdate.bottom - m_nBorder + 7 ) / (m_nPixelSize + m_nGapSize) )) / 8;
		
	CBrush brushBlack(RGB(0,0,0));
	CBrush brushBg(DISPLAY_BGCOLOR);

	for(int y=rectUpdate.top; y<rectUpdate.bottom; y++)
	{
		rect.left = m_nBorder;
		for(int x=rectUpdate.left; x<rectUpdate.right; x++)
		{
			rect.top = m_nBorder + y * 8*(m_nPixelSize + m_nGapSize);
			int nByte=m_display[(y)*DISPLAY_WIDTH+x];
			for(int nBit=0;nBit<8;nBit++, nByte/=2)
			{
				rect.right = rect.left + m_nPixelSize;
				rect.bottom = rect.top + m_nPixelSize;
				dc.FillRect(rect, (nByte&1) ? &brushBlack : &brushBg);
				rect.top+=(m_nPixelSize + m_nGapSize);
			}
			rect.left += (m_nPixelSize + m_nGapSize);
		}
	}
}

void CDisplay::SetGeometry(int nPixelSize, int nGapSize, int nBorder)
{
	m_nPixelSize = nPixelSize;
	m_nGapSize = nGapSize;
	m_nBorder = nBorder;
	CRect rect(0,0,2*nBorder + DISPLAY_WIDTH*(nPixelSize+nGapSize)-nGapSize, 2*nBorder+DISPLAY_HEIGHT*(nPixelSize+nGapSize)-nGapSize);

	CalcWindowRect(rect);
	SetWindowPos(NULL, 0,0,rect.Width(), rect.Height(), SWP_NOMOVE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	UpdateWindow();
}

BOOL CDisplay::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
//	CRect rect;
//	GetClientRect(rect);
//	pDC->FillSolidRect(rect, DISPLAY_BGCOLOR);
	return CStatic::OnEraseBkgnd(pDC);
}

void CDisplay::WriteData(WORD nOffset, WORD nSize, BYTE* buffer)
{
	ASSERT(nOffset+ nSize <= DISPLAY_WIDTH*DISPLAY_HEIGHT/8);
	memcpy(&m_display[nOffset], buffer, min(nSize, DISPLAY_WIDTH*DISPLAY_HEIGHT/8- nOffset));
}
