// EmuThread.cpp : implementation file
//

#include "stdafx.h"
#include "PXAEmu.h"
#include "EmuThread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEmuThread

IMPLEMENT_DYNCREATE(CEmuThread, CWinThread)

CEmuThread::CEmuThread()
{
	m_bAutoDelete = true;
}

CEmuThread::~CEmuThread()
{
}

BOOL CEmuThread::InitInstance()
{
	CString strPipe;
	strPipe = "\\\\.\\pipe\\PhonePipe";
	m_hPipe = CreateNamedPipe(
		strPipe,                             // pipe name
		PIPE_ACCESS_DUPLEX /*| FILE_FLAG_OVERLAPPED*/,     // pipe open mode
		PIPE_TYPE_BYTE | PIPE_WAIT,                           // pipe-specific modes
		2,                        // maximum number of instances
		1024,                       // output buffer size
		1024,                        // input buffer size
		60000,                      // time-out interval
		NULL // SD
	);
	
	if (m_hPipe==INVALID_HANDLE_VALUE) 
	{
		return FALSE;
	}

	ConnectNamedPipe(m_hPipe, NULL);
	return TRUE;
}

int CEmuThread::ExitInstance()
{
	// TODO:  perform any per-thread cleanup here
	if (m_hPipe!=INVALID_HANDLE_VALUE)
	{
		CloseHandle(m_hPipe);
	}
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CEmuThread, CWinThread)
	//{{AFX_MSG_MAP(CEmuThread)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEmuThread message handlers

int CEmuThread::Run() 
{
	BYTE buffer[2048];
	BOOL bResult;

	PostMessage(m_hWndDlg, WM_PIPE_CONNECTED, 1, 0);

	bool bInData = false;
	WORD nOffset, nSize;
	
	DWORD nBytesToRead, nBytesRead, nRead;
	nBytesRead = 0;
	nBytesToRead = 4;
	while( m_hPipe!=INVALID_HANDLE_VALUE )
	{
		if (!PeekNamedPipe(
			m_hPipe,              // handle to pipe
			NULL,                // data buffer
			0,              // size of data buffer
			NULL,            // number of bytes read
			&nRead,      // number of bytes available
			NULL // unread bytes
			))
		{
			break;
		}
		
		if (!nRead)
		{
			Sleep(50);
			continue;
		}
		
		
		bResult = ReadFile(m_hPipe, &buffer[nBytesRead], nBytesToRead, &nRead, NULL); 
		nBytesRead+=nRead;
		if (!bInData)
		{
			if (nBytesRead==4)
			{
				bInData = true;
				nOffset = *((WORD*)&buffer[0]);
				nSize = *((WORD*)&buffer[2]);

				nBytesToRead = nSize;
				nBytesRead = 0;
			} else
			{
				nBytesToRead = 4-nBytesRead;
			}
		} else
		{
			if (nBytesRead==nSize)
			{ // Complete data
				SendMessage(m_hWndDlg, WM_DATA_MSG, MAKEWPARAM(nOffset, nSize), (long)buffer);
				bInData = false;
				nBytesRead = 0;
				nBytesToRead = 4;
			}
		}
	}	
	PostMessage(m_hWndDlg, WM_PIPE_CONNECTED, 0, 0);
	return 0; //CWinThread::Run();
}

bool CEmuThread::SendKey(int nKey, bool bDown)
{
	if (m_hPipe==INVALID_HANDLE_VALUE) 
	{
		return false;
	}

	BYTE buffer[2];
	DWORD nWritten;
	buffer[0] = 'K';
	buffer[1] = (0x20+nKey+1) | (bDown ? 0: 0x80);
	
	WriteFile(m_hPipe, buffer, 2, &nWritten, NULL);
	return true;
}
