// PXAEmuDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PXAEmu.h"
#include "PXAEmuDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define KEY_SPACING 10
/////////////////////////////////////////////////////////////////////////////
// CPXAEmuDlg dialog

CPXAEmuDlg::CPXAEmuDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPXAEmuDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPXAEmuDlg)
	m_nGap = 0;
	m_nPixelSize = 2;
	m_nBorder = 5;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_nBmpIndex = 0;
}

void CPXAEmuDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPXAEmuDlg)
	DDX_Control(pDX, IDC_DISPLAY, m_ctrlDisplay);
	DDX_Text(pDX, IDC_TXT_GAP, m_nGap);
	DDV_MinMaxUInt(pDX, m_nGap, 0, 10);
	DDX_Text(pDX, IDC_TXT_PIXELSIZE, m_nPixelSize);
	DDV_MinMaxUInt(pDX, m_nPixelSize, 1, 10);
	DDX_Text(pDX, IDC_TXT_BORDER, m_nBorder);
	DDV_MinMaxUInt(pDX, m_nBorder, 0, 20);
	DDX_Control(pDX, IDC_PC, m_pc);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPXAEmuDlg, CDialog)
	ON_MESSAGE( WM_PIPE_CONNECTED, OnPipeConnected )
	ON_MESSAGE( WM_DATA_MSG, OnDataMsg )
	
	//{{AFX_MSG_MAP(CPXAEmuDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_UPDATE_GEOM, OnBtnUpdateGeom)
	ON_WM_CTLCOLOR()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BTN_COPY_DISPLAY, OnBtnCopyDisplay)
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPXAEmuDlg message handlers

afx_msg LRESULT CPXAEmuDlg::OnPipeConnected(WPARAM w, LPARAM l)
{
	SetConnected(w==1);
	if (w==0)
	{
		m_thread = NULL;
		StartThread();
	}
	return 0;
}
BOOL CPXAEmuDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CheckDlgButton(IDC_BTN26, 1);
	
//	
	SetConnected(false)	;
	StartThread();
/*
	m_thread.SetDlgWnd(GetSafeHwnd());
	m_thread.CreateThread();
	
	UpdateLayout();
	SetTimer(1, 100, NULL);
*/
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPXAEmuDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		//CDialog::OnPaint();
		CPaintDC dc(this);
		CRect rect;
		GetClientRect(rect);
		dc.FillSolidRect(rect, RGB(0,0,0));
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPXAEmuDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CPXAEmuDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	WORD nID = LOWORD(wParam);
	if (nID>=IDC_BTN00 && nID<=IDC_BTN29)
	{
		m_thread->SendKey(nID-1000, 0!=IsDlgButtonChecked(nID));
		if (IsDlgButtonChecked(nID) && nID !=IDC_BTN26)
		{
			CheckDlgButton(nID, 0);
			m_thread->SendKey(nID-1000, 0!=IsDlgButtonChecked(nID)); 
		}
	}
	return CDialog::OnCommand(wParam, lParam);
}

void CPXAEmuDlg::UpdateLayout()
{
	CRect 
		rectDisplay, rectDKbd, rectKbd, 
		rectItem00, rectItem06, rectItem10;
	m_ctrlDisplay.SetGeometry(m_nPixelSize,m_nGap, m_nBorder);
	m_ctrlDisplay.GetWindowRect(rectDisplay);

	rectDKbd.SetRectEmpty();
	GetDlgItem(IDC_BTN00)->GetWindowRect(rectItem00);

	rectDKbd.right += rectItem00.Width() * 2 + 2* KEY_SPACING + rectDisplay.Width();
	rectDKbd.bottom = max(rectItem00.Height() * 3 + 2* KEY_SPACING, rectDisplay.Height());
	
	
	
	rectKbd.SetRectEmpty();
	GetDlgItem(IDC_BTN06)->GetWindowRect(rectItem06);
	GetDlgItem(IDC_BTN10)->GetWindowRect(rectItem10);

	rectKbd.right = rectItem06.Width() * 2 + rectItem10.Width() * 3 + 4 * KEY_SPACING;
	rectKbd.bottom = rectItem10.Height() * 5 + 4 * KEY_SPACING;

	
	int nMaxWidth = max(rectKbd.Width(), rectDKbd.Width());

	rectDKbd.OffsetRect(150 + (nMaxWidth - rectDKbd.Width())/2, KEY_SPACING);
	rectKbd.OffsetRect(150 + (nMaxWidth - rectKbd.Width())/2, rectDKbd.bottom + KEY_SPACING);

	m_ctrlDisplay.SetWindowPos(NULL, rectDKbd.left + rectItem00.Width() + KEY_SPACING, rectDKbd.top + (rectDKbd.Height() - rectDisplay.Height()) / 2,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	
	{
		int nGap = (rectDKbd.Height() - 3*rectItem00.Height()) / 2 ;
		GetDlgItem(IDC_BTN00)->SetWindowPos(NULL, rectDKbd.left, rectDKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
		GetDlgItem(IDC_BTN01)->SetWindowPos(NULL, rectDKbd.left, rectItem00.Height() + nGap + rectDKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
		GetDlgItem(IDC_BTN02)->SetWindowPos(NULL, rectDKbd.left, 2*(rectItem00.Height() + nGap) + rectDKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
		
		GetDlgItem(IDC_BTN03)->SetWindowPos(NULL, rectDKbd.right - rectItem00.Width(), rectDKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
		GetDlgItem(IDC_BTN04)->SetWindowPos(NULL, rectDKbd.right - rectItem00.Width(), rectItem00.Height() + nGap + rectDKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
		GetDlgItem(IDC_BTN05)->SetWindowPos(NULL, rectDKbd.right - rectItem00.Width(), 2*(rectItem00.Height() + nGap) + rectDKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	}

	GetDlgItem(IDC_BTN06)->SetWindowPos(NULL, rectKbd.left, rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	GetDlgItem(IDC_BTN07)->SetWindowPos(NULL, rectKbd.left, (rectItem00.Height() + KEY_SPACING) + rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	GetDlgItem(IDC_BTN08)->SetWindowPos(NULL, rectKbd.left, 2*(rectItem00.Height() + KEY_SPACING) + rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	GetDlgItem(IDC_BTN09)->SetWindowPos(NULL, rectKbd.left, 3*(rectItem00.Height() + KEY_SPACING) + rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);


	GetDlgItem(IDC_BTN10)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + rectItem06.Width(), rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	GetDlgItem(IDC_BTN11)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + rectItem06.Width(), (rectItem00.Height() + KEY_SPACING) + rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	GetDlgItem(IDC_BTN12)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + rectItem06.Width(), 2*(rectItem00.Height() + KEY_SPACING) + rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	GetDlgItem(IDC_BTN13)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + rectItem06.Width(), 3*(rectItem00.Height() + KEY_SPACING) + rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);

	GetDlgItem(IDC_BTN14)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + (KEY_SPACING + rectItem10.Width()) + rectItem06.Width(), rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	GetDlgItem(IDC_BTN15)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + (KEY_SPACING + rectItem10.Width()) + rectItem06.Width(), (rectItem00.Height() + KEY_SPACING) + rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	GetDlgItem(IDC_BTN16)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + (KEY_SPACING + rectItem10.Width()) + rectItem06.Width(), 2*(rectItem00.Height() + KEY_SPACING) + rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	GetDlgItem(IDC_BTN17)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + (KEY_SPACING + rectItem10.Width()) + rectItem06.Width(), 3*(rectItem00.Height() + KEY_SPACING) + rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	
	GetDlgItem(IDC_BTN18)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + 2 * (KEY_SPACING + rectItem10.Width()) + rectItem06.Width(), rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	GetDlgItem(IDC_BTN19)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + 2 * (KEY_SPACING + rectItem10.Width()) + rectItem06.Width(), (rectItem00.Height() + KEY_SPACING) + rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	GetDlgItem(IDC_BTN20)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + 2 * (KEY_SPACING + rectItem10.Width()) + rectItem06.Width(), 2*(rectItem00.Height() + KEY_SPACING) + rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	GetDlgItem(IDC_BTN21)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + 2 * (KEY_SPACING + rectItem10.Width()) + rectItem06.Width(), 3*(rectItem00.Height() + KEY_SPACING) + rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);

	GetDlgItem(IDC_BTN22)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + 3 * (KEY_SPACING + rectItem10.Width()) + rectItem06.Width(), rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	GetDlgItem(IDC_BTN23)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + 3 * (KEY_SPACING + rectItem10.Width()) + rectItem06.Width(), (rectItem00.Height() + KEY_SPACING) + rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	GetDlgItem(IDC_BTN24)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + 3 * (KEY_SPACING + rectItem10.Width()) + rectItem06.Width(), 2*(rectItem00.Height() + KEY_SPACING) + rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	GetDlgItem(IDC_BTN25)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + 3 * (KEY_SPACING + rectItem10.Width()) + rectItem06.Width(), 3*(rectItem00.Height() + KEY_SPACING) + rectItem00.Height() + KEY_SPACING + rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);


	GetDlgItem(IDC_BTN27)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + rectItem06.Width(), rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	GetDlgItem(IDC_BTN28)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + (KEY_SPACING + rectItem10.Width()) + rectItem06.Width(), rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);
	GetDlgItem(IDC_BTN29)->SetWindowPos(NULL, rectKbd.left + KEY_SPACING + 2 * (KEY_SPACING + rectItem10.Width()) + rectItem06.Width(), rectKbd.top,0,0, SWP_NOSIZE | SWP_NOACTIVATE | SWP_NOREDRAW|SWP_NOZORDER);

	{
		CRect rect(0,0, max(rectDKbd.right, rectKbd.right) +KEY_SPACING, rectKbd.bottom + KEY_SPACING);
		CalcWindowRect(rect);
		SetWindowPos(NULL, 0,0,rect.Width(), rect.Height(), SWP_NOMOVE | SWP_NOZORDER);
	}
	RedrawWindow();
}

void CPXAEmuDlg::OnBtnUpdateGeom() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	UpdateLayout();
}


HBRUSH CPXAEmuDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
   HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

   if (pWnd->GetDlgCtrlID() == IDC_STATIC)
   {
      pDC->SetTextColor(RGB(255, 255, 255));
      pDC->SetBkMode(TRANSPARENT);
      hbr = (HBRUSH)::GetStockObject(BLACK_BRUSH);
   }

   return hbr;
}

void CPXAEmuDlg::SetConnected(bool bConnected)
{
	for (int i= IDC_BTN00; i <= IDC_BTN29; i++)
	{
		GetDlgItem(i)->EnableWindow(bConnected);
	}
}

void CPXAEmuDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	m_thread->SuspendThread();
}

afx_msg LRESULT CPXAEmuDlg::OnDataMsg(WPARAM w, LPARAM l)
{
	m_ctrlDisplay.WriteData(LOWORD(w), HIWORD(w), (BYTE*)l);
	return 0;
}

void CPXAEmuDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	m_ctrlDisplay.Invalidate();
	CDialog::OnTimer(1);
}
HANDLE DDBToDIB(CBitmap &bitmap, DWORD dwCompression,
                CPalette *pPal);

void CPXAEmuDlg::OnBtnCopyDisplay() 
{
//	m_ctrlDisplay. // TODO: Add your control notification handler code here

	    // TODO: Add your command handler code here
    CBitmap     cBmp;
    CClientDC   cWndDC(&m_ctrlDisplay);   // View is an hWnd, so we can use "this"
    CDC         cMemDC;         // Handle to a memory DC
    CRect     rect;             // For storing the size of the window

    cMemDC.CreateCompatibleDC(&cWndDC); // Create the memory DC.
    m_ctrlDisplay.GetWindowRect(rect);         // Get the size of the window
    // Here we are going to do a little drawing so we can see a line.
  
    cBmp.CreateCompatibleBitmap(&cWndDC, rect.Width(),rect.Height() );
    // Keep the old bitmap
    CBitmap* pOldBitmap = cMemDC.SelectObject(&cBmp);

    cMemDC.BitBlt(0, 0, rect.Width(),rect.Height(), &cWndDC, 0, 0, SRCCOPY);

    // here are the actual clipboard functions.
    AfxGetApp()->m_pMainWnd->OpenClipboard() ;
    EmptyClipboard() ;
    SetClipboardData (CF_BITMAP, cBmp.GetSafeHandle() ) ;
    CloseClipboard () ;
        // next we select the old bitmap back into the memory DC
        // so that our bitmap is not deleted when cMemDC is destroyed.
        // Then we detach the bitmap handle from the cBmp object so that
        // the bitmap is not deleted when cBmp is destroyed.
	
	// Create logical palette if device support a palette
	CPalette pal;
	if( cWndDC.GetDeviceCaps(RASTERCAPS) & RC_PALETTE )
	{
		UINT nSize = sizeof(LOGPALETTE) + (sizeof(PALETTEENTRY) * 256);
		LOGPALETTE *pLP = (LOGPALETTE *) new BYTE[nSize];
		pLP->palVersion = 0x300;

		pLP->palNumEntries = 
			GetSystemPaletteEntries( cWndDC, 0, 255, pLP->palPalEntry );

		// Create the palette
		pal.CreatePalette( pLP );

		delete[] pLP;
	}

    cMemDC.SelectObject(pOldBitmap);
  
	// Convert the bitmap to a DIB
	HANDLE hDIB = DDBToDIB( cBmp, BI_RGB, &pal );


  if(hDIB==NULL)
    return;

  {
	CString str;
	str.Format("d:\\File%04X.bmp", m_nBmpIndex++);
	  CFile m_file;
	  if(!m_file.Open(str,CFile::modeWrite |
					  CFile::modeCreate,NULL))
		return;
	  BITMAPFILEHEADER hdr;
	  LPBITMAPINFOHEADER lpbi;
	  lpbi=(LPBITMAPINFOHEADER ) hDIB;

	  int nColors = 
		  lpbi->biBitCount > 8
		  ? 0 
		  : (1 << lpbi->biBitCount);

	  hdr.bfType= ((WORD) ('M' << 8) | 'B');
	  hdr.bfSize=sizeof(hdr) + GlobalSize(hDIB);
	  hdr.bfReserved1=0;
	  hdr.bfReserved2=0;
	  hdr.bfOffBits=(DWORD) sizeof(hdr) + nColors * sizeof(RGBQUAD) + sizeof(BITMAPINFOHEADER);
	  m_file.Write(&hdr,sizeof(hdr));
	  m_file.Write(lpbi,GlobalSize(hDIB));
	  m_file.Close();


	}
	// Free the memory allocated by DDBToDIB for the DIB
	GlobalFree( hDIB );
	cBmp.Detach();
}
		
		
		
HANDLE DDBToDIB(CBitmap &bitmap, DWORD dwCompression,
                CPalette *pPal)
{

  BITMAP              bm;
  BITMAPINFOHEADER    bi;
  LPBITMAPINFOHEADER  lpbi;
  DWORD               dwLen;
  HANDLE              hDIB;
  HANDLE              handle;
  HDC                 hDC;
  HPALETTE            hPal;


  ASSERT( bitmap.GetSafeHandle() );

  // The function has no arg for bitfields
  if( dwCompression == BI_BITFIELDS )
    return NULL;

  // If a palette has not been supplied, use default palette
  hPal = (HPALETTE) pPal->GetSafeHandle();
  if (hPal==NULL)
    hPal = (HPALETTE) GetStockObject(DEFAULT_PALETTE);

  // Get bitmap information
  bitmap.GetObject(sizeof(bm),(LPSTR)&bm);

  // Initialize the bitmap infoheader
  bi.biSize          = sizeof(BITMAPINFOHEADER);
  bi.biWidth         = bm.bmWidth;
  bi.biHeight        = bm.bmHeight;
  bi.biPlanes        = 1;
  bi.biBitCount      = 1; //bm.bmPlanes * bm.bmBitsPixel;
    //bm.bmPlanes    * bm.bmBitsPixel;
  bi.biCompression   = dwCompression;
  bi.biSizeImage     = 0;
  bi.biXPelsPerMeter = 0;
  bi.biYPelsPerMeter = 0;
  bi.biClrUsed       = 0;
  bi.biClrImportant  = 0;

  // Compute the size of the infoheader and the color table
	int nColors =
	  bi.biBitCount > 8
	  ? 0 
	  : (1 << bi.biBitCount);
	
	dwLen  = bi.biSize + nColors * sizeof(RGBQUAD);

  // We need a device context to get the DIB from
  hDC = ::GetDC(NULL);
  hPal = SelectPalette(hDC,hPal,FALSE);
  RealizePalette(hDC);

  // Allocate enough memory to hold bitmap infoheader and
  // color table
  hDIB = GlobalAlloc(GMEM_FIXED,dwLen);

  if (!hDIB){
    SelectPalette(hDC,hPal,FALSE);
    ::ReleaseDC(NULL,hDC);
    return NULL;
  }

  lpbi = (LPBITMAPINFOHEADER)hDIB;

  *lpbi = bi;

  // Call GetDIBits with a NULL lpBits param, so the device
  // driver will calculate the biSizeImage field
  GetDIBits(hDC, (HBITMAP)bitmap.GetSafeHandle(), 0L,
                 (DWORD)bi.biHeight,
                 (LPBYTE)NULL, (LPBITMAPINFO)lpbi,
                 (DWORD)DIB_RGB_COLORS);

  bi = *lpbi;

  // If the driver did not fill in the biSizeImage field, then
  // compute it
  // Each scan line of the image is aligned on a DWORD (32bit)
  // boundary
  if (bi.biSizeImage == 0){
    bi.biSizeImage = ((((bi.biWidth * bi.biBitCount) + 31)
                        & ~31) / 8) * bi.biHeight;

    // If a compression scheme is used, the result may in fact
    // be larger
    // Increase the size to account for this.
    if (dwCompression != BI_RGB)
      bi.biSizeImage = (bi.biSizeImage * 3) / 2;
  }

  // Realloc the buffer so that it can hold all the bits
  dwLen += bi.biSizeImage;
  if (handle = GlobalReAlloc(hDIB, dwLen, GMEM_MOVEABLE))
    hDIB = handle;
  else{
    GlobalFree(hDIB);

    // Reselect the original palette
    SelectPalette(hDC,hPal,FALSE);
    ::ReleaseDC(NULL,hDC);
    return NULL;
  }

  // Get the bitmap bits
  lpbi = (LPBITMAPINFOHEADER)hDIB;

  // FINALLY get the DIB
  BOOL bGotBits = GetDIBits( hDC, (HBITMAP)bitmap.GetSafeHandle(),
        0L,                        // Start scan line
        (DWORD)bi.biHeight,        // # of scan lines
        (LPBYTE)lpbi               // address for bitmap bits
        + (bi.biSize + nColors * sizeof(RGBQUAD)),
        (LPBITMAPINFO)lpbi,        // address of bitmapinfo
        (DWORD)DIB_RGB_COLORS);    // Use RGB for color table

  if( !bGotBits )
  {
    GlobalFree(hDIB);

    SelectPalette(hDC,hPal,FALSE);
    ::ReleaseDC(NULL,hDC);
    return NULL;
  }

  SelectPalette(hDC,hPal,FALSE);
  ::ReleaseDC(NULL,hDC);

  return hDIB;

//End of the function
}

void CPXAEmuDlg::StartThread()
{
	m_thread = new CEmuThread();

	m_thread->SetDlgWnd(GetSafeHwnd());
	m_thread->CreateThread();
	
	UpdateLayout();
	SetTimer(1, 100, NULL);
}

void CPXAEmuDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	if (nChar == 'P')
	{
		OnBtnCopyDisplay();
		return;
	}
/*
	int nID;
	switch (nChar)
	{
	case 0x60: nID = IDC_BTN17 ; break;
	case 0x61: nID = IDC_BTN10 ; break;
	case 0x62: nID = IDC_BTN14 ; break;
	case 0x63: nID = IDC_BTN18 ; break;
	case 0x64: nID = IDC_BTN11 ; break;
	case 0x65: nID = IDC_BTN15 ; break;
	case 0x66: nID = IDC_BTN19 ; break;
	case 0x67: nID = IDC_BTN12 ; break;
	case 0x68: nID = IDC_BTN16 ; break;
	case 0x69: nID = IDC_BTN20 ; break;
	default:
	}
	CheckDlgButton(nID, 0);
*/
	CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
	
}

void CPXAEmuDlg::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnKeyUp(nChar, nRepCnt, nFlags);
}
